#include <iostream>
using namespace std;

#include "Signature.h"
#include "Board.h"

void print( Board &b );
void print( BoardSig &s );
void quad( QuadSig &q, int a[4][4] );
int twobit( int source, int pos );

void print( Board &b ){	
	cout<<"---BOARD---\n";
	for( int y=0; y<8; y++ ){
		for( int x=0; x<8; x++){
			switch( b(x,y) ){
				case -1:
					cout<<"X";
					break;
				case 0:
					cout<<".";
					break;
				case 1:
					cout<<"O";
					break;
				default:
					cout<<"F";
					break;
			}
		}
		cout<<endl;
	}	
}
void print( BoardSig &s ){	
	int b[8][8];
	int q[4][4];
	
	// abcd
	// efgh
	// ijkl
	// mnop
	// ----0--------
	//      PONM
	//      LKJI
	//      HGFE
	//      ECBA	
	quad( s.A, q );
	b[0][0] = q[3][3];
	b[1][0] = q[2][3];
	b[2][0] = q[1][3];
	b[3][0] = q[0][3];
	b[0][1] = q[3][2];
	b[1][1] = q[2][2];
	b[2][1] = q[1][2];
	b[3][1] = q[0][2];
	b[0][2] = q[3][1];
	b[1][2] = q[2][1];
	b[2][2] = q[1][1];
	b[3][2] = q[0][1];
	b[0][3] = q[3][0];
	b[1][3] = q[2][0];
	b[2][3] = q[1][0];
	b[3][3] = q[0][0];
	
	
	// abcd
	// efgh
	// ijkl
	// mnop
	//0-----
	// MIEA
	// NJFB
	// OKGC
	// PLHD
	quad( s.B, q );
	b[4][0] = q[3][0]; //a
	b[5][0] = q[3][1];
	b[6][0] = q[3][2];
	b[7][0] = q[3][3];
	b[4][1] = q[2][0]; //e
	b[5][1] = q[2][1];
	b[6][1] = q[2][2];
	b[7][1] = q[2][3];
	b[4][2] = q[1][0]; //i
	b[5][2] = q[1][1];
	b[6][2] = q[1][2];
	b[7][2] = q[1][3];
	b[4][3] = q[0][0]; //m
	b[5][3] = q[0][1];
	b[6][3] = q[0][2];
	b[7][3] = q[0][3];
	
	quad( s.C, q );
	for( int x=0; x<4; x++ ){
		for( int y=0; y<4; y++ )
			b[4+x][4+y] = q[x][y];
	}
	
	//----0----
	//abcd|DHLP
	//efgh|CGKO
	//ijkl|BFJN
	//mnop|AEIM
	quad( s.D, q );
	b[0][4] = q[0][3];
	b[1][4] = q[0][2];
	b[2][4] = q[0][1];
	b[3][4] = q[0][0];
	b[0][5] = q[1][3];
	b[1][5] = q[1][2];
	b[2][5] = q[1][1];
	b[3][5] = q[1][0];
	b[0][6] = q[2][3];
	b[1][6] = q[2][2];
	b[2][6] = q[2][1];
	b[3][6] = q[2][0];
	b[0][7] = q[3][3];
	b[1][7] = q[3][2];
	b[2][7] = q[3][1];
	b[3][7] = q[3][0];
	
	cout<<"++++SIG++++\n";
	for( int y=0; y<8; y++ ){
		for( int x=0; x<8; x++){
			switch( b[x][y] ){
				case -1:
					cout<<"X";
					break;
				case 0:
					cout<<".";
					break;
				case 1:
					cout<<"O";
					break;
			}
		}
		cout<<endl;
	}
		
	
	
	
}
void quad( QuadSig &q, int a[4][4] ){
	//diag=(q[0][0]) + (q[1][1]<<2) + (q[2][2]<<4) + (q[3][3]<<6);
	//	right =(q[1][0])+(q[2][0]<<2)+(q[3][0]<<4)+(q[1][2]<<6)+(q[1][3]<<8)+
	//			(q[2][3]<<10);
	//	left=(q[0][1])+(q[0][2]<<2)+(q[0][3]<<4)+(q[2][1]<<6)+(q[3][1]<<8)+
	//			(q[3][2]<<10);
	a[0][0] = twobit( q.diag, 0 );
	a[1][1] = twobit( q.diag, 2 );
	a[2][2] = twobit( q.diag, 4 );
	a[3][3] = twobit( q.diag, 6 );
	
	a[1][0] = twobit( q.left, 0 );
	a[2][0] = twobit( q.left, 2 );
	a[3][0] = twobit( q.left, 4 );
	a[1][2] = twobit( q.left, 6 );
	a[1][3] = twobit( q.left, 8 );
	a[2][3] = twobit( q.left, 10);
	
	a[0][1] = twobit( q.right, 0 );
	a[0][2] = twobit( q.right, 2 );
	a[0][3] = twobit( q.right, 4 );
	a[2][1] = twobit( q.right, 6 );
	a[3][1] = twobit( q.right, 8 );
	a[3][2] = twobit( q.right, 10);
}
int twobit( int source, int pos ){
	return (source - ((source >>  pos+2 ) << pos+2)) >> pos;
}

int main( void ){
	Board b;
	for( int x=0; x<8; x++ ){
		for( int y=0; y<8; y++ ){
			b(x,y) = 0;
		}
	}
	
	for( int x=0; x<8; x++ ){
		for( int y=0; y<8; y++){
			b(7-x,y)=-1;
			print(b);
			BoardSig bs(b);
			print(bs);
		}
	}
	
	return 0;	
}
