/*
    This file is part of Reversi DS.

    Reversi DS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Reversi DS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Reversi DS.  If not, see <http://www.gnu.org/licenses/>.
     
    http://ReversiDS.sourceforge.net
*/
#pragma once
//#include <nds.h>

class Board{
private:
	/**
	 * check if a line
	 */
	int validLine(int x,int y,int dx,int dy,int color)const;
	/**
	 * check a line of pieces starting at (x,y) in the direction of (dx,dy)
	 * to see if pieces need to be flipped.  If so flip pieces and return 1
	 */
	int updateLine(int x,int y,int dx,int dy,int color);
	int b[8][8];
public:
	enum{B=-1,BU,E=0,W=1,WU};
	int& operator()(int x,int y){
		return b[x][y];
	}
	int operator()(int x,int y)const{
		return b[x][y];
	}
	//void operator=(const Board &that){
	//	for(int x=0;x<8;x++)
	//		for(int y=0;y<8;y++)
	//			b[x][y]=that.b[x][y];
	//}
	//Board(const Board &that){
	//	*this=that;
	//}
	Board(){};
	/**
	 * check if play (x,y,color) is legal
	 */ 
	int valid(int x,int y, int color)const;
	/**
	 * place a piece at (x,y) if valid
	 * flip requist lines
	 */ 
	int play(int x,int y,int color);
};

