/*
    This file is part of Reversi DS.

    Reversi DS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Reversi DS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Reversi DS.  If not, see <http://www.gnu.org/licenses/>.
     
    http://ReversiDS.sourceforge.net
*/
#pragma once

#include <nds.h>
#include "Sprite.h"
#include "Board.h"
#include "Global.h"

class Game{
public:
	Board b;
	int turn;
	Game(){
		for(int x=0;x<8;x++)
		for(int y=0;y<8;y++)
			b(x,y)=0;
		b(3,3)=b.B;
		b(4,4)=b.B;
		b(3,4)=b.W;
		b(4,3)=b.W;
		turn=b.B;
		
	}
	void play(int x,int y){
		int bx=(x-BOARD_START_X)/BOARD_STEP;
		int by=(y-BOARD_START_Y)/BOARD_STEP;
		if(bx<0 || bx>=8 || by<0 || by>=8)
			return;
		if(b.play(bx,by,turn)){
			nextTurn();
			if(openPlays()==0)
				nextTurn();
		}
	}
	void boardPlay(int x,int y){
		if(b.play(x,y,turn)){
			nextTurn();
			if(!openPlays())
				nextTurn();
		}
	}
	void nextTurn(){
		if(turn==b.B)
			turn=b.W;
		else
			turn=b.B;			
	}
	int openPlays(){
		return openPlays(turn);
	}
	int openPlays(int t){
		for(int x=0;x<8;x++){
			for(int y=0;y<8;y++){
				if(b.valid(x,y,t))
					return 1;
			}
		}
		return 0;			
	}
	int endGame(){
		if(openPlays(b.B))
			return 0;
		if(openPlays(b.W))
			return 0;
		return 1;
	}
	int score(int v){
		int s=0;
		for(int x=0;x<8;x++){
			for(int y=0;y<8;y++){
				if(b(x,y)==v)
					s++;
			}
		}
		return s;
	}
};

