/*
    This file is part of Reversi DS.

    Reversi DS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Reversi DS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Reversi DS.  If not, see <http://www.gnu.org/licenses/>.
     
    http://ReversiDS.sourceforge.net
*/
#pragma once

class Gfx{
public:
	int rows;
	int cols;
	int size;
	u16* data;
	Gfx( const void* ptr, int cols, int rows )
		:rows(rows),cols(cols),size(rows*cols),data(NULL){
			data = new u16[size];
			if( data )
				decompress(ptr,data,LZ77);
			else {
				rows=cols=size=0;
			}
	}
	Gfx( const Gfx& that )
	:rows(that.rows),cols(that.cols),size(that.size),data(NULL){
		data = new u16[size];
		if( data ){
			for(int x=0;x<size;++x)
				data[x] = that.data[x];
		} else {
			rows =cols = size = 0;
		}		
	}
	~Gfx(){
		delete [] data;
		data = NULL;
	}
	const Gfx& operator=(const Gfx& that){
		if( this == &that )
			return *this;
		delete [] data; data = NULL;
		rows = that.rows;
		cols = that.cols;
		size = that.size;
		data = new u16[size];
		if( data ){
			for(int x=0;x<size;x++)
				data[x] = that.data[x];
		} else {
			rows = cols= size =0;
		}
		return *this;
	}
	
};


	
	
	
