/*
    This file is part of Reversi DS.

    Reversi DS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Reversi DS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Reversi DS.  If not, see <http://www.gnu.org/licenses/>.
     
    http://ReversiDS.sourceforge.net
*/
#pragma once
#include "OthelloMove.h"
#include "Board.h"
#include "Signature.h"
#include <vector>
using namespace std;
class OthelloData{
	Board b;
	BoardSig sig;
	enum{ PREV=-1,EMPTY=0,DANGER,PLACED,PROTECTED =5,SAFE =10};
	
	int turn;
	int freeMoves;
	
	int evalPiece(int,int,int,int)const;
public:
	OthelloMove lastMove;

	OthelloData(const Board &,int,const OthelloMove &);
	~OthelloData();
	OthelloData(const OthelloData &that)
	:b(that.b),sig(that.sig),turn(that.turn),freeMoves(that.freeMoves),lastMove(that.lastMove){}
	void operator=(const OthelloData &that){
		b=that.b;
		turn=that.turn;
		freeMoves=that.freeMoves;
		sig = that.sig;
		lastMove = that.lastMove;
	}
	int evaluate() const;
	int ended() const;
	vector<OthelloData> enumerateOptions() const;	
	int rank()const{
		return freeMoves;
	}
	const BoardSig& getSig()const{
		return sig;
	}
	bool operator<(const OthelloData &that)const{
		return rank()<that.rank();
	}
};
